//
// C++ Interface: kalvacmd
//
// Description: 
//
//
// Author: Andreas Silberstorff <andreas@andreas-silberstorff.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KALVACMD_H
#define KALVACMD_H

#include <qstring.h>
#include <qdatetime.h>

class QWidget;

/**
Build Player- and Recordercommand

@author Andreas Silberstorff
*/
class kalvaCmd : public QString
{
//Q_OBJECT

public:
    kalvaCmd( QWidget * p );
    ~kalvaCmd();

    virtual void playCmd(       const QString & channel,
                                  const QString & freq
                                  );
    virtual void playCmdDVB(
                                  const QString & station
                                  );
    virtual void recordCmd(
                                  const QString & filmtitle,
                                  const QString & station,
                                  const QString & duration,
                                  const QString & channel,
                                  const QString & freq
                                  );
    virtual void recordCmdDVB(
                                  const QString & filmtitle,
                                  const QString & station,
                                  const QString & duration
                                  );
    virtual void recordCmdDVBAsDivX4(
                                  const QString & filmtitle,
                                  const QString & station,
                                  const QString & duration
                                  );

private:
    virtual void setTitle(      const QString & filmtitle,
                                  const QString & station
                              );
    virtual QString setTuner();
    virtual void prepareAumix();
    virtual void setAumixPrePlay();
    virtual void setAumixPostPlay();
    virtual void setAumixPreRec();
    virtual void setAumixPostRec();
    virtual void setNice();
    virtual void setURLtv();
    virtual void setURLdvb();
    virtual void setInputOptsTV( QString & Opts);
    virtual void setInputOptsPost( QString & Opts);
    virtual void setLavcOpts( QString & Opts );
    virtual void setEncoderOptsPost( QString & Opts);
    virtual void setFilterRect( QString & filter );
    virtual void setFilterCrop( QString & filter );
    virtual void setFilterPre( QString & filter );
    virtual void setFilterPP( QString & filter );
    virtual void setFilterScale( QString & filter );
    virtual void setFilterAspect( QString & filter );
    virtual void setFilterDenoiser( QString & filter );
    virtual void setFilterPost( QString & filter );
    virtual void setBitrate( QString & lavcOpts );
    virtual double Bitrate();
    virtual void setVerbosity();

    QWidget * parent;
    QString aumix;
    QString aumixdev;
    QString m_station;
    QString m_freq;
    QString m_channel;
    QString driver;
    QString norm;
    QString tv_scale;
    QString x_scale;
    QString y_scale;
    QString start;
    QString dow;
    QTime m_duration;
};

#endif
